LeetCode hot100-89

https://leetcode.cn/problems/partition-equal-subset-sum/description/?envType=study-plan-v2\&envId=top-100-liked

java 复制代码
416. 分割等和子集
已解答
中等
相关标签
相关企业
给你一个 只包含正整数 的 非空 数组 nums 。请你判断是否可以将这个数组分割成两个子集,使得两个子集的元素和相等。

问题分析:

目标是将数组分成两个子集,并且这两个子集的和相等。假设数组 nums 的总和为 S。

如果 S 是奇数,显然无法将数组分割成两个和相等的子集,因为两个相等的子集的和必然是偶数。

如果 S 是偶数,目标是找到一个子集,使得其和为 S / 2。也就是说,问题转化为 判断是否存在一个子集,其和为 S / 2。

动态规划解法:

定义 dpi 为是否存在一个子集,其和为 i。

初始化 dp0 = true,表示和为 0 的子集是存在的(即空子集)。

对每个数 num,从后往前更新 dp 数组:如果 dpj - num 为 true,则 dpj 也可以为 true,表示可以选择该 num 来组成和为 j 的子集。

第二层循环从target到num自己才能保证dp被更新

java 复制代码
类似于
处理 num = 1:
我们更新 dp[j] 从 j = 11 到 j = 1:
dp[11] = dp[11] || dp[11 - 1] = false || false = false
dp[10] = dp[10] || dp[10 - 1] = false || false = false
dp[9] = dp[9] || dp[9 - 1] = false || false = false
dp[8] = dp[8] || dp[8 - 1] = false || false = false
dp[7] = dp[7] || dp[7 - 1] = false || false = false
dp[6] = dp[6] || dp[6 - 1] = false || false = false
dp[5] = dp[5] || dp[5 - 1] = false || false = false
dp[4] = dp[4] || dp[4 - 1] = false || false = false
dp[3] = dp[3] || dp[3 - 1] = false || false = false
dp[2] = dp[2] || dp[2 - 1] = false || false = false
dp[1] = dp[1] || dp[1 - 1] = false || true = true → dp[1] = true
java 复制代码
class Solution {
    public boolean canPartition(int[] nums) {
        int sum=0;
        for(int i=0;i<nums.length;i++){
            sum += nums[i];
        }
        if(sum%2!=0){
            return false;
        }
        sum=sum/2;
        boolean[] dp = new boolean[sum+1];
        dp[0]=true;
        for(int num : nums){
            for(int i=sum;i>=num;i--){
                dp[i]=dp[i]||dp[i-num];
            }
        }
        return dp[sum];
    }
}
相关推荐
dialect_14 小时前
CODEFORCES ROUND 1127 DIV2
开发语言·c++·算法
Nuanyt14 小时前
LeetCode Hot 100 链表专题(四)· 3 题(Java)
java·算法·leetcode·链表·双指针
灯澜忆梦14 小时前
LeetCode 1861. 旋转盒子|Go 双指针解法
算法
软件派15 小时前
生产动态数据智能风控:阈值判别、趋势预测、异常识别算法工程落地实战
前端·数据库·算法
ZhengEnCi1 天前
模型训练完整流程:从数据准备到模型上线的 10 个关键步骤(全文可跑)
后端·算法
weixin_307779131 天前
RAG 面试陷阱——混合检索并非无条件优越:一个条件反转实验
人工智能·python·面试·职场和发展
吞下星星的少年·-·1 天前
Div.3 CF 1131A题(排序,模拟)
算法·模拟·排序
圣保罗的大教堂1 天前
leetcode 453. 最小操作次数使数组元素相等 中等
leetcode
aichitang20241 天前
代数拓扑学与现代前沿视角
考研·算法·数学建模·ai·拓扑学·高考